org.apache.xerces.impl.io

## Class ASCIIReader

- java.lang.Object
- - java.io.Reader
  - - org.apache.xerces.impl.io.ASCIIReader

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable, java.lang.Readable

      public final class ASCIIReader
      extends java.io.Reader

  A simple ASCII byte reader. This is an optimized reader for reading byte streams that only contain 7-bit ASCII characters.
  Version:
    $Id: ASCIIReader.java 718096 2008-11-16 20:00:58Z mrglavas $
  Author:
    Andy Clark, IBM

  # INTERNAL:

    Usage of this class is not supported. It may be altered or removed at any time.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `DEFAULT_BUFFER_SIZE` Default byte buffer size (2048).
    `protected byte[]` | `fBuffer` Byte buffer.
    `protected java.io.InputStream` | `fInputStream` Input stream.

    - ### Fields inherited from class java.io.Reader

      `lock`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ASCIIReader(java.io.InputStream inputStream, byte[] buffer, MessageFormatter messageFormatter, java.util.Locale locale)` Constructs an ASCII reader from the specified input stream and buffer.
    `ASCIIReader(java.io.InputStream inputStream, int size, MessageFormatter messageFormatter, java.util.Locale locale)` Constructs an ASCII reader from the specified input stream and buffer size.
    `ASCIIReader(java.io.InputStream inputStream, MessageFormatter messageFormatter, java.util.Locale locale)` Constructs an ASCII reader from the specified input stream using the default buffer size.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Close the stream.
    `void` | `mark(int readAheadLimit)` Mark the present position in the stream.
    `boolean` | `markSupported()` Tell whether this stream supports the mark() operation.
    `int` | `read()` Read a single character.
    `int` | `read(char[] ch, int offset, int length)` Read characters into a portion of an array.
    `boolean` | `ready()` Tell whether this stream is ready to be read.
    `void` | `reset()` Reset the stream.
    `long` | `skip(long n)` Skip characters.

    - ### Methods inherited from class java.io.Reader

      `read, read`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_BUFFER_SIZE

          public static final int DEFAULT_BUFFER_SIZE

      Default byte buffer size (2048).
      See Also:
        Constant Field Values

    - #### fInputStream

          protected final java.io.InputStream fInputStream

      Input stream.

    - #### fBuffer

          protected final byte[] fBuffer

      Byte buffer.

  - ### Constructor Detail

    - #### ASCIIReader

          public ASCIIReader(java.io.InputStream inputStream,
                     MessageFormatter messageFormatter,
                     java.util.Locale locale)

      Constructs an ASCII reader from the specified input stream using the default buffer size.
      Parameters:
        `inputStream` - The input stream.
        `messageFormatter` - the MessageFormatter to use to message reporting.
        `locale` - the Locale for which messages are to be reported

    - #### ASCIIReader

          public ASCIIReader(java.io.InputStream inputStream,
                     int size,
                     MessageFormatter messageFormatter,
                     java.util.Locale locale)

      Constructs an ASCII reader from the specified input stream and buffer size.
      Parameters:
        `inputStream` - The input stream.
        `size` - The initial buffer size.
        `messageFormatter` - the MessageFormatter to use to message reporting.
        `locale` - the Locale for which messages are to be reported

    - #### ASCIIReader

          public ASCIIReader(java.io.InputStream inputStream,
                     byte[] buffer,
                     MessageFormatter messageFormatter,
                     java.util.Locale locale)

      Constructs an ASCII reader from the specified input stream and buffer.
      Parameters:
        `inputStream` - The input stream.
        `buffer` - The byte buffer.
        `messageFormatter` - the MessageFormatter to use to message reporting.
        `locale` - the Locale for which messages are to be reported

  - ### Method Detail

    - #### read

          public int read()
                   throws java.io.IOException

      Read a single character. This method will block until a character is available, an I/O error occurs, or the end of the stream is reached.

      Subclasses that intend to support efficient single-character input should override this method.

      Overrides:
        `read` in class `java.io.Reader`
      Returns:
        The character read, as an integer in the range 0 to 127 (`0x00-0x7f`), or -1 if the end of the stream has been reached
      Throws:
        `java.io.IOException` - If an I/O error occurs

    - #### read

          public int read(char[] ch,
                 int offset,
                 int length)
                   throws java.io.IOException

      Read characters into a portion of an array. This method will block until some input is available, an I/O error occurs, or the end of the stream is reached.
      Specified by:
        `read` in class `java.io.Reader`
      Parameters:
        `ch` - Destination buffer
        `offset` - Offset at which to start storing characters
        `length` - Maximum number of characters to read
      Returns:
        The number of characters read, or -1 if the end of the stream has been reached
      Throws:
        `java.io.IOException` - If an I/O error occurs

    - #### skip

          public long skip(long n)
                    throws java.io.IOException

      Skip characters. This method will block until some characters are available, an I/O error occurs, or the end of the stream is reached.
      Overrides:
        `skip` in class `java.io.Reader`
      Parameters:
        `n` - The number of characters to skip
      Returns:
        The number of characters actually skipped
      Throws:
        `java.io.IOException` - If an I/O error occurs

    - #### ready

          public boolean ready()
                        throws java.io.IOException

      Tell whether this stream is ready to be read.
      Overrides:
        `ready` in class `java.io.Reader`
      Returns:
        True if the next read() is guaranteed not to block for input, false otherwise. Note that returning false does not guarantee that the next read will block.
      Throws:
        `java.io.IOException` - If an I/O error occurs

    - #### markSupported

          public boolean markSupported()

      Tell whether this stream supports the mark() operation.
      Overrides:
        `markSupported` in class `java.io.Reader`

    - #### mark

          public void mark(int readAheadLimit)
                    throws java.io.IOException

      Mark the present position in the stream. Subsequent calls to reset() will attempt to reposition the stream to this point. Not all character-input streams support the mark() operation.
      Overrides:
        `mark` in class `java.io.Reader`
      Parameters:
        `readAheadLimit` - Limit on the number of characters that may be read while still preserving the mark. After reading this many characters, attempting to reset the stream may fail.
      Throws:
        `java.io.IOException` - If the stream does not support mark(), or if some other I/O error occurs

    - #### reset

          public void reset()
                     throws java.io.IOException

      Reset the stream. If the stream has been marked, then attempt to reposition it at the mark. If the stream has not been marked, then attempt to reset it in some way appropriate to the particular stream, for example by repositioning it to its starting point. Not all character-input streams support the reset() operation, and some support reset() without supporting mark().
      Overrides:
        `reset` in class `java.io.Reader`
      Throws:
        `java.io.IOException` - If the stream has not been marked, or if the mark has been invalidated, or if the stream does not support reset(), or if some other I/O error occurs

    - #### close

          public void close()
                     throws java.io.IOException

      Close the stream. Once a stream has been closed, further read(), ready(), mark(), or reset() invocations will throw an IOException. Closing a previously-closed stream, however, has no effect.
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in class `java.io.Reader`
      Throws:
        `java.io.IOException` - If an I/O error occurs

Copyright © 1999-2022 The Apache Software Foundation. All Rights Reserved.